#ifdef DETERMINATE
#define PUSH_LIMIT 14
#endif

#ifdef BASELINE
#define PUSH_LIMIT 14
#endif

#ifdef TENPERCENT
#define PUSH_LIMIT 14
#endif

#ifdef ONEPERCENT
#define PUSH_LIMIT 1024
#endif

#define PUSH(apl,apu,arr,alr,brr,blr,art,agm,agr) \
    if (maxqueue < PUSH_LIMIT) {\
    queue_ptr = &queue[maxqueue++]; \
    queue_ptr->aprecisionlower = apl; \
    queue_ptr->aprecisionupper = apu; \
    queue_ptr->aleftremoved = alr; \
    queue_ptr->arightremoved = arr; \
    queue_ptr->bleftremoved = blr; \
    queue_ptr->brightremoved = brr; \
    queue_ptr->arodstree = art; \
    queue_ptr->agranulesmid = agm; \
    queue_ptr->agranulesrange = agr;} 

#define POP(apl,apu,arr,alr,brr,blr,art,agm,agr) \
 if (currentqueue == maxqueue) return FALSE; \
 else { \
  queue_ptr = &queue[currentqueue++]; \
  apl = queue_ptr->aprecisionlower; \
  apu = queue_ptr->aprecisionupper; \
  alr = queue_ptr->aleftremoved; \
  arr = queue_ptr->arightremoved; \
  blr = queue_ptr->bleftremoved; \
  brr = queue_ptr->brightremoved; \
  art = queue_ptr->arodstree; \
  agm = queue_ptr->agranulesmid; \
  agr = queue_ptr->agranulesrange; \
  }

bool before(int gamma, tempevent_type *alpha, tempevent_type *beta) 
{
  int  target, mal_target, i, j;
  bool found, wentright;
  tree_node_type *atemp, *btemp, *bprevious;
  unsigned int agranulesmidapprox, bgranulesmidapprox, currentqueue;
  tree_node_type *brodstree, *arodstree;
  queue_node_type *queue_ptr;
  unsigned int agranuleslower, agranulesupper, bgranuleslower,
               bgranulesupper, agranulesmid, bgranulesmid, 
	       aprecisionlower, aprecisionupper, aprecisionmid,
	       bprecisionlower, bprecisionupper, bprecisionmid,
	       agranulesrange, bgranulesrange, x1, y1, x2, y2,
	       agranulesmidapproxceil, 
	       agranulesmidapproxfloor, bgranulesmidapproxfloor,
               bgranulesmidinitial, bgranulesrangeinitial, 
	       bgranulesmidapproxceil, temp, shiftfactor;

  unsigned int bleftremoved,  brightremoved, aleftremoved, arightremoved;

#define MULT(i,j) ((i < MULT_TABLE_MAX) && (j < MULT_TABLE_MAX))? mult_table[i][j]: i*j

  /* Determinate precedes? */
#ifdef BASELINE
  return TRUE;
#endif

  if (alpha->upper < beta->lower) return TRUE;
#ifdef DETERMINATE
  return FALSE;
#endif

  if (beta->upper < alpha->lower) return FALSE;

  /* Assert --> The periods of indeterminacy must overlap */

  /* Need a determinate before?*/ /* Is this true? */
  /*
  if (gamma == 100) return FALSE;
  */

  /* Is the indeterminacy trivial? */ /* Is this true? */
  /*
  if (gamma == 1) return TRUE;
  */

  target = pregammas[gamma];
  mal_target = pregammas[100 - gamma];

  /*
  agranuleslower = alpha->lower << 16;
  agranulesupper = (alpha->upper + 1) << 16;
  */
  agranuleslower = alpha->lower;
  agranulesupper = alpha->upper + 1;
  aprecisionlower = 0;
  aprecisionupper = PRECISION;
  bprecisionlower = 0;
  bprecisionupper = PRECISION;
  arodstree = uniform_tree;
  /*
  bgranuleslower = beta->lower << 16;
  bgranulesupper = (beta->upper + 1) << 16;
  */
  bgranuleslower = beta->lower;
  bgranulesupper = beta->upper;
  brodstree = uniform_tree; 
  aleftremoved = 0;
  arightremoved = 0;
  bleftremoved = 0;
  brightremoved = 0;

  /* Coerce granules to something in the range 1 to COARSENESS */
  if (agranuleslower < bgranuleslower) {
    /* Adjust to make alpha lower the origin */
    bgranuleslower -= agranuleslower;
    bgranulesupper -= agranuleslower;
    agranulesupper -= agranuleslower;
    agranuleslower = 0;
    }
  else {
    /* Adjust to make beta lower the origin */
    agranuleslower -= bgranuleslower;
    agranulesupper -= bgranuleslower;
    bgranulesupper -= bgranuleslower;
    bgranuleslower = 0;
    }
  /* Fix total range to be in 1 to COARSENES */
  agranuleslower++;
  agranulesupper++;
  bgranuleslower++;
  bgranulesupper++;
  temp = (agranulesupper > bgranulesupper)? agranulesupper : bgranulesupper;
  for (shiftfactor = 0; temp > 0x8000; temp >>= shiftfactor, shiftfactor++);
  agranuleslower <<= 16 - shiftfactor;
  agranulesupper <<= 16 - shiftfactor;
  bgranulesupper <<= 16 - shiftfactor;
  bgranuleslower <<= 16 - shiftfactor;


  /* Make initial guesses */
  if ((agranulesupper >> 16) < (bgranulesupper >> 16)) {
    bgranulesrange = ((bgranulesupper - bgranuleslower) >> 1);
    bgranulesmid = bgranulesrange + bgranuleslower;
    btemp = brodstree;
    bprevious = NULL;
    for(; btemp;) {
      bgranulesmidapprox = ((bgranulesmid - 1) >> 16);
      if (((agranulesupper-1)>>16) < bgranulesmidapprox) {
        bgranulesrange = bgranulesrange >> 1;
        bgranulesmid -= bgranulesrange;
	bprevious = btemp;
        btemp = btemp->left;
        }
      else {
        bgranulesrange = bgranulesrange >> 1;
        bgranulesmid += bgranulesrange;
        btemp = btemp->right;
        }
      }
    if (bprevious) {
      target -= PRECISION * bprevious->rightrods;
      if (target <= 0) return TRUE;
      brightremoved = bprevious->rightrods;
      }
    }
  if ((bgranuleslower >> 16) < (agranuleslower >> 16)) {
    bgranulesrange = ((bgranulesupper - bgranuleslower) >> 1);
    bgranulesmid = bgranulesrange + bgranuleslower;
    btemp = brodstree;
    bprevious = NULL;
    for(; btemp;) {
      bgranulesmidapprox = ((bgranulesmid - 1) >> 16);
      if ((agranuleslower>>16) < bgranulesmidapprox) {
        bgranulesrange = bgranulesrange >> 1;
        bgranulesmid -= bgranulesrange;
	bprevious = btemp;
        btemp = btemp->left;
        }
      else {
        bgranulesrange = bgranulesrange >> 1;
        bgranulesmid += bgranulesrange;
        btemp = btemp->right;
        }
      }
    if (bprevious) {
      mal_target -= PRECISION * bprevious->leftrods;
      if (mal_target <= 0) return FALSE;
      bleftremoved = bprevious->leftrods;
      }
    else {
      mal_target -= PRECISION * PRECISION;
      if (mal_target <= 0) return FALSE;
      bleftremoved = PRECISION;
      }
    }

  maxmaxqueue = (maxqueue > maxmaxqueue)? maxqueue: maxmaxqueue;
  currentqueue = 0;
  maxqueue = 0;
  agranulesrange = ((agranulesupper - agranuleslower) >> 1);
  agranulesmid = agranulesrange + agranuleslower;
  atemp = arodstree;
  bgranulesrangeinitial = ((bgranulesupper - bgranuleslower) >> 1);
  bgranulesmidinitial = bgranulesrangeinitial + bgranuleslower;

  do {
    aprecisionmid = aprecisionlower + (1 + (aprecisionupper - aprecisionlower) >> 1);
#ifdef TESTING
    printf("gamma %d target %d mal_target %d \n   aprecisionmid %d, aprecisionlower %d, aprecisionupper %d\n",
             gamma, target, mal_target, aprecisionmid, aprecisionlower, aprecisionupper);
#endif

    agranulesrange = ((agranulesupper - agranuleslower) >> 1);
    agranulesmid = agranulesrange + agranuleslower;
    atemp = arodstree;
    /* Find right end of midrod in alpha */
    for (found = FALSE;!found;){ 
      if (atemp->value > aprecisionmid) {
        agranulesrange = agranulesrange >> 1;
        agranulesmid -= agranulesrange;
        atemp = atemp->left;
        }
      else if (atemp->value < aprecisionmid) {
        agranulesrange = agranulesrange >> 1;
        agranulesmid += agranulesrange;
        atemp = atemp->right;
        }
      else { 
	found = TRUE;
	}
      }
    /*
    agranulesmid = (agranulesrange * aprecisionmid) >> 8;
    */

    agranulesmidapproxfloor = (agranulesmid - 1) >> 16;
    agranulesmidapproxceil = agranulesmid >> 16;

    bgranulesrange = bgranulesrangeinitial;
    bgranulesmid = bgranulesmidinitial;

    btemp = brodstree;
    if ((bgranulesmid >> 16) > agranulesmidapproxceil) bprevious = brodstree;
    else bprevious = NULL;
    /* Find the granule to the right of the target granule in alpha */
    wentright = FALSE;
    for(;btemp;) {
      bgranulesrange = bgranulesrange >> 1;
      /*
      printf("%d agranules %d bgranules %d\n", i++, agranulesmidapproxfloor, bgranulesmid >> 16);
      */
      if (agranulesmidapproxfloor < (bgranulesmid >> 16)) {
        /* go left */
        bgranulesmid -= bgranulesrange;
        bprevious = btemp;
        btemp = btemp->left;
        }
      else { 
        /* go right */
        wentright = TRUE;
        bgranulesmid += bgranulesrange;
        btemp = btemp->right;
        }
      }

    if (bprevious) {
#ifdef TESTING
      printf("Left, Right %d %d %d %d\n", atemp->leftrods, aleftremoved, bprevious->rightrods, brightremoved);
#endif 
      x1 = atemp->leftrods - aleftremoved;
      y1 = bprevious->rightrods - brightremoved;
      x2 = bprevious->leftrods - bleftremoved;
      y2 = atemp->rightrods - arightremoved;
      if (x1 < 0 || y1 < 0 || x1 > PRECISION || y1 > PRECISION) 
	       /*printf("i %d j %d\n", x1, y1)*/; 
      else target -= MULT(x1, y1);
      if (target <= 0) return TRUE;
      if ((aprecisionmid - aprecisionlower) > 1) {
        PUSH(aprecisionlower,aprecisionmid,
	     arightremoved + y2, aleftremoved,
	     brightremoved + y1, bleftremoved,
	     atemp,agranulesmid,agranulesrange);
        }

      if (wentright) /* then there is something to the left */ {
#ifdef TESTING
      printf("Right, Left\n");
#endif 
      if (x2 < 0 || y2 < 0 || x2 > PRECISION || y2 > PRECISION) 
	       /*printf("i %d j %d\n", x2, y2)*/; 
      mal_target -= MULT(x2, y2);
      if (mal_target <= 0) return FALSE;
      if ((aprecisionupper - aprecisionmid) > 1) {
        PUSH(aprecisionmid,aprecisionupper,
             arightremoved, aleftremoved + x1,
	     brightremoved, bleftremoved + x2,
	     atemp,agranulesmid,agranulesrange);
        }
      }
      }
    else {/* couldn't find any such point, ergo all of beta is before pivot*/ 
#ifdef TESTING
      printf("Left, Right %d %d %d %d\n", atemp->leftrods, aleftremoved, bprevious->rightrods, brightremoved);
#endif 
      x2 = PRECISION - bleftremoved;
      y2 = atemp->rightrods - arightremoved;
      if (x2 < 0 || y2 < 0 || x2 > PRECISION || y2 > PRECISION) 
	       /*printf("i %d j %d\n", x2, y2)*/; 
      mal_target -= MULT(x2, y2);
      if (mal_target <= 0) return FALSE;

      if ((aprecisionupper - aprecisionmid) > 1) {
        PUSH(aprecisionmid,aprecisionupper,
             arightremoved, aleftremoved + x1,
	     brightremoved, bleftremoved + x2,
	     atemp,agranulesmid,agranulesrange);
        }
      }
      
    POP(aprecisionlower,aprecisionupper,
        arightremoved,aleftremoved,
        brightremoved,bleftremoved,
	atemp,agranulesmid,agranulesrange);

  } while (maxqueue >= currentqueue);
  return FALSE; /*default action */
}
