#include <stdio.h>
#include <sys/time.h>
#include "system_wide.h"
#include "tadt_internal/tadt_intind.h"
#include "tadt/tadt_ext.h"

static node_space_type nodes[500];
static int free_nodes, occupied_nodes;
static unsigned short mult_200_by_200[202][202];
static int power2[] = {1,2,4,8,16,32,64,128,256,512,1024};
static unsigned long ev1shifted[16]; 
static unsigned long ev2shifted[16]; 
static unsigned long ev1all[100]; 
static unsigned long ev2all[100]; 
static unsigned long bits[16]; 

#define SC_MAX    8
#define SSC_MAX 256
#define MIN 0
#define MAX 10000
static unsigned long uni_prob_to_sc[MAX];

void main() {
  int i, j;
  dist_space_type uniform;
  ind_space_type ev1, ev2;
  bool before(), eval;
  void printf();
  struct timeval tp1, tp2;
  int temp1, temp2, numoftrials;

  for (i=0;i<202;i++) {
    for (j=0;j<202;j++) {
      mult_200_by_200[i][j] = i * j;
      }
    }

  j = 1;
  for (i=0; i<16; i++) {
    bits[i] = j;
    j <<= 1;
    }

  for (i=MIN; i<MAX; i++) uni_prob_to_sc[i] = (65536*(i+1))/MAX;

  for (i=1;i<100;i++) {
    uniform.LO_to_sc[i] = (i*256)/100;
    }
  uniform.LO_to_sc[1] = 1;
  uniform.LO_to_sc[0] = 1;

  for (i=1;i<100;i++) {
    uniform.RO_to_sc[i] = ((100-i)*256)/100;
    }

  uniform.RO_to_sc[100] = 1;
  uniform.RO_to_sc[101] = 1;
  uniform.RO_to_sc[1] = 256;
  uniform.RO_to_sc[0] = 256;

  for (i=1;i<258;i++) {
    uniform.sc_to_SP[i] = (100*i)/256;
    }
  for (i=1;i<257;i++) {
    uniform.sc_to_TP[i+1] = 100 - ((100*i)/256);
    }

  uniform.sc_to_TP[1] = 100;

  /* event_type(1, 256, 0, 0, 0, 0, 0, 0, 0, uniform, 0) */
  ev1.start = 1;
  ev1.finish = 256;
  ev1.left_offset = 0;
  ev1.right_offset = 0;
  ev1.dist = &uniform;

  /* event_type(128 , 127+256, 0, 0, 0, 0, 0, 0, 0, uniform, 0) */
  ev2.start = 128;
  ev2.finish = 127 + 256;
  ev2.left_offset = 0;
  ev2.right_offset = 0;
  ev2.dist = &uniform;

  /* event_type(1, 200000, 0, 0, 0, 0, 0, 0, 0, uniform, 0) */
  ev1.start = 1;
  ev1.finish = 200000;
  ev1.left_offset = 0;
  ev1.right_offset = 0;
  ev1.dist = &uniform;

  /* event_type(1000001, 3000000, 0, 0, 0, 0, 0, 0, 0, uniform, 0) */
  ev2.start = 1000001;
  ev2.finish = 3000000;
  ev2.left_offset = 0;
  ev2.right_offset = 0;
  ev2.dist = &uniform;

  /* event_type(1, 2000000, 0, 0, 0, 0, 0, 0, 0, uniform, 0) */
  ev1.start = 1;
  ev1.finish = 2000000;
  ev1.left_offset = 0;
  ev1.right_offset = 0;
  ev1.dist = &uniform;

  /* event_type(1, 2000000, 0, 0, 0, 0, 0, 0, 0, uniform, 0) */
  /*
  ev2.start = 1;
  ev2.finish = 2000000;
  ev2.left_offset = 0;
  ev2.right_offset = 0;
  ev2.dist = &uniform;
  */

  numoftrials = 100 /*300*/;
  for (i=1;i<2/*101*/;i++) {

    gettimeofday(&tp1,NULL);

    for (j=1; j<=numoftrials; j++) eval = before(50/*i*/, &ev1, &ev2);

    gettimeofday(&tp2,NULL);

    /* Old print stuff
    if (eval) printf("TRUE %d\n", i);
    else printf("False %d\n", i);
    printf("%d.%d\n", tp1.tv_sec, tp1.tv_usec);
    printf("%d.%d\n", tp2.tv_sec, tp2.tv_usec);
    temp1 = tp1.tv_sec * 1000000 + tp1.tv_usec;
    temp2 = tp2.tv_sec * 1000000 + tp2.tv_usec;
    temp1 = temp2 - temp1;
    printf("%d  %d\n\n", temp1/1000, temp1);
    */

    printf("%d\n", i);
    temp1 = tp1.tv_sec * 1000000 + tp1.tv_usec;
    temp2 = tp2.tv_sec * 1000000 + tp2.tv_usec;
    temp1 = temp2 - temp1;
    printf("%d\n", temp1/numoftrials);
    printf("%d\n", free_nodes);
    if (eval) printf("TRUE %d %d\n", i);
    else printf("False %d %d\n", i);

    }

}

unsigned long long va[256], vb[256];

bool before(int gamma, ind_type ev1, ind_type ev2)
{
  int i, j;
  unsigned long probe, left, right, mid, range, test;
  unsigned long r1, r2, s1, s2;
  unsigned long prob_right, prob_left, target;

  target = gamma * 100;
  ev1->range = (ev1->finish - ev1->start) + 1;
  ev2->range = (ev2->finish - ev2->start) + 1;
  ev1->sc_size = ev1->range >> 16;
  ev2->sc_size = ev2->range >> 16; 

  /*
  for (i=0; i<200; i++) {
    ev1all[i] = 0;
    ev2all[i] = 0;
    }
  */

  ev1shifted[15] = ev1->range >> 1;        
  ev2shifted[15] = ev2->range >> 1;        
  /*
  printf("j %d ev1 %d ev2 %d\n", ev1shifted[15], ev2shifted[15],15);
  */
  for (i=14; i>=0; i--) {
    ev1shifted[i] = ev1shifted[i+1] >> 1;        
    ev2shifted[i] = ev2shifted[i+1] >> 1;        
    /*
    printf("j %d ev1 %d ev2 %d\n", ev1shifted[i], ev2shifted[i],i);
    */
    }

  probe = ev1->finish;
  probe -= ev2->start;
  /*
  printf("probe %d\n", probe);
  */
  for (j=15, mid=0; j>=0; j--) {
    mid <<=1;
    if (probe > ev2shifted[j]) {
      probe -= ev2shifted[j];
      mid++;
      }
    }
    /*
    printf("mid %d j %d probe %d ev2 %d\n", mid, j, probe, ev2shifted[j]);
    */

  probe = mid;
  left = MIN;
  right = MAX; 
  for (;(right - left) > 1;) {
    range = right-left;
    mid  = (range >> 1) + left;
    test = uni_prob_to_sc[mid];
    if (test > probe) {
      right = mid;
      }
    else {
      left = mid;
      }
 /*
 printf("%d %d %d %d %d %d\n", left, right, range, mid, test, probe);
 getchar();
 */
    }
  prob_right = 100-right;

  probe = ev2->start;
  probe -= ev1->start;
  for (j=15, mid=0; j>=0; j--) {
    mid <<= 1;
    if (probe > ev1shifted[j]) {
      probe -= ev1shifted[j];
      mid++;
      }
    }
    /*
    printf("mid %d j %d probe %d ev2 %d\n", mid, j, probe, ev2shifted[j]);
    */

  probe = mid;
  left = MIN;
  right = MAX; 
  for (;(right - left) > 1;) {
    range = right-left;
    mid  = (range >> 1) + left;
    test = uni_prob_to_sc[mid];
    if (test > probe) {
      right = mid;
      }
    else {
      left = mid;
      }
    }
 /*
 printf("%d %d %d %d %d %d\n", left, right, range, mid, test, probe);
 getchar();
 */

  prob_left = left;
  target -= prob_right * prob_left;

  /*
  printf("target %d %d %d %d\n", target, prob_right, prob_left, gamma);
  getchar();
  */
  if (target == gamma) return TRUE;
  else return FALSE;

  /*
  for (i=0; i<100; i++) {
    r1 = 1;
    s1 = 0;
    s2 = 0;
    for (j=0; j<8; j++) {
      if (r1 & uni_prob_to_sc[i]) {
	s1 += ev1shifted[j];
	}
      if (r1 & uni_prob_to_sc[i]) {
	s2 += ev2shifted[j];
	}
      r1 <<= 1;
      }
    ev1all[i] = s1;
    ev2all[i] = s2;
    ev1all[i] = ev1->sc_size*uni_prob_to_sc[i];
    ev2all[i] = ev2->sc_size*uni_prob_to_sc[i];
    }
    */

  for (j=15, mid=0; j>=0; j--, mid <<= 1) {
/*
    printf("mid %d j %d probe %d ev2 %d\n", mid, j, probe, ev2shifted[j]);
*/
    if (probe > ev2shifted[j]) {
      probe -= ev2shifted[j];
      mid++;
      }
    }

  probe = ev2->start;
  probe -= ev1->start;
  for (j=15, mid=0; j>=0; j--, mid <<= 1) {
/*
    printf("mid %d j %d probe %d ev2 %d\n", mid, j, probe, ev1shifted[j]);
*/
    if (probe > ev1shifted[j]) {
      probe -= ev1shifted[j];
      mid++;
      }
    }

/*
  printf("mid %d\n", mid);
  getchar();
*/

  /*
  probe = ev1->finish;
  probe -= ev2->start;
  left = 0;
  right = 99; 
  for (;(right - left) > 1;) {
    range = right-left;
    mid  = (range >> 1) + left;
    */
    /*
    test = uni_prob_to_sc[mid] * ev2->sc_size;
    */
    /*
    test = 0;
    for (j=0; j<8; j++) if (bits[j] & uni_prob_to_sc[mid]) {
      */
      /*
      printf("j %d\n", j);
      getchar();
      */
      /*
      test += ev2shifted[j];
      }
    */
    /*
    if (!ev2all[mid]) {
      s1 = 0;
      for (j=0; j<16; j++) if (bits[j] & uni_prob_to_sc[mid]) s1 += ev2shifted[j];
      ev2all[mid] = s1;
      }
    test = ev2all[mid];
    */
    /*
    if (!ev2all[mid]) {
      r1 = 1;
      s2 = 0;
      for (j=0; j<16; j++) {
        if (r1 & uni_prob_to_sc[i]) {
 	  s2 += ev2shifted[j];
	  }
        r1 <<= 1;
        }
      ev2all[mid] = s2;
      }
    test = ev2all[mid];
    */
    /*
    if (test > probe) {
      right = mid;
      }
    else {
      left = mid;
      }
    */
/*
 printf("%d %d %d %d %d %d\n", left, right, range, mid, test, probe);
 getchar();
 */
    /*
    }
    */
 /*
 printf("%d %d %d %d %d %d\n", left, right, range, mid, test, probe);
 */
/*
  prob_right = 100-right;

  probe = ev2->start;
  probe -= ev1->start;
  left = 0;
  right = 99; 
  for (;(right - left) > 1;) {
    range = right-left;
    mid  = (range >> 1) + left;
*/
    /*
    ev1all[mid] = uni_prob_to_sc[mid] * ev1->sc_size;
    */
/*
    test = uni_prob_to_sc[mid] * ev1->sc_size;
*/
    /*
    if (!ev1all[mid]) {
      s1 = 0;
      for (j=0; j<16; j++) if (bits[j] & uni_prob_to_sc[mid]) s1 += ev1shifted[j];
      ev1all[mid] = s1;
      }
    test = ev1all[mid];
    */
    /*
    test = uni_prob_to_sc[mid] * ev1->sc_size;
    */
/*
    if (test > probe) {
      right = mid;
      }
    else {
      left = mid;
      }
*/
/*
printf("%d %d %d %d %d %d\n", left, right, range, mid, test, probe);
getchar();
*/
/*
    }
*/

/*
 printf("%d %d %d %d %d %d\n", left, right, range, mid, test, probe);
*/
/*
  prob_left = left;
  target -= prob_right * prob_left;

  if (target == gamma) return TRUE;
  else return FALSE;
*/
  /*
  printf("%x\n", ev1->sc_size);
  printf("%x\n", ev2->sc_size);
  printf("%x\n", uni_prob_to_sc[49]);
  printf("%d\n", uni_prob_to_sc[49]);
  printf("%d\n", uni_prob_to_sc[99]);
  */

  /*
  ev1->sc_range = SC_MAX * SSC_MAX;
  ev2->sc_range = SC_MAX * SSC_MAX;
  ev1->off_sc = (ev2->start - ev1->start) + 1;
  ev2->off_sc = (ev1->finish - ev2->start) + 1;
  ev1->ssc_range = ev1->sc_range*ev2->sc_range;
  ev2->ssc_range = ev1->ssc_range;
  */

  /*
  printf("zzz %x %x %x\n", uni_prob_to_sc[49] * ev1->sc_size, ev1->range, 
	  uni_prob_to_sc[49]);
  printf("zzz %d %d %d\n", uni_prob_to_sc[49] * ev1->sc_size, ev1->range, 
	  uni_prob_to_sc[49]);
  */
  /*
  ev1->sc_size*;
  r1 = 0;
  for (i = 0; i < 256; i++) {
    r1 += ev1->sc_size;
    va[i] = r1;
    }  
  */

  /*
  r1 = left*j;
  */
  /*
  left = 4087;
  j = 65535;
  for (right=1; right <= 500; right++, j--, left++) {
  r1 = 0;
  r2 = 1;
  for (i = 1; i <= 16; i++) {
    if (i & j) {
       r1 += left << i;
      }
    r2 <<= 1;
    }
  if (r1 == right) printf("hello");
  }
  */

  if (ev1->start == ev2->finish) return TRUE;
  else return FALSE;
}       

bool beforej(int gamma, ind_type ev1, ind_type ev2) 
{
  static void chr_to_sc();
  static void dump_ind_event(ind_type);
  unsigned long off;
  unsigned short prob1, prob2, denom1, denom2, 
		prob_left, prob_right, range1, range2, prob1_left,
		prob1_right, prob2_left, prob2_right, mid1, mid2;
  int  must_before, prob_before, target, mal_target;
  int sane_left, sane_right;
  node_type t;
  dist_type dist1, dist2;
  bool out1, out2;


/*
ev1->range = (ev1->finish - ev1->start) + 1;
ev2->range = (ev2->finish - ev2->start) + 1;
ev1->sc_size = ev1->range / (SC_MAX * SSC_MAX);
ev2->sc_size = ev2->range / (SC_MAX * SSC_MAX);
ev1->sc_range = SC_MAX * SSC_MAX;
ev2->sc_range = SC_MAX * SSC_MAX;
ev1->off_sc = (ev2->start - ev1->start) + 1;
ev2->off_sc = (ev1->finish - ev2->start) + 1;
ev1->ssc_range = ev1->sc_range*ev2->sc_range;
ev2->ssc_range = ev1->ssc_range;

if (1==1) return TRUE;
*/

  /* Determinate precedes? */
  if (ev2->finish <= ev1->start) return FALSE;
  if (ev1->finish < ev2->start) return TRUE;

  /* Assert --> The periods of indeterminacy must overlap */

  /* Need an indeterminate before */
  if (gamma == 100) return FALSE;

  /* Is the indeterminacy trivial? */
  if (gamma == 1) return TRUE;

/*
printf("before\n");
printf("before\n");
*/
  /* Need to fix this up */
  if (ev1->start <= ev2->start) {
    off = (ev2->start - ev1->start) + 1;
    /*
    chr_to_sc(ev1,&off); 
    */
  {
  int sum, i, remain, temp;

  ev1->from_sc = ev1->dist->LO_to_sc[ev1->left_offset + 1];
  ev1->to_sc = ev1->dist->RO_to_sc[ev1->right_offset + 1];
  ev1->range = (ev1->finish - ev1->start) + 1;
  ev1->sc_range = (ev1->to_sc - ev1->from_sc) + 1;

  remain = off;
  sum = 0;
  temp = ev1->range;
  for (i=0; i<8; i++) {
    temp = temp >> 1;
    /*
    printf(" temp %x %d sum %d remain %d\n", temp, temp, sum, remain);
    */
    if (temp <= remain) {
      remain -= temp;
      sum += power2[7-i];
      }
    } 
  
  ev1->sc_size = sum;
  ev1->off_sc = ((ev1->sc_range * sum) >> 8) + ev1->from_sc;
/*
printf(" temp %x %d sum %d remain %d\n", temp, temp, sum, remain);
*/
  }

    off = (ev1->finish - ev2->start) + 1;
    /*
    chr_to_sc(ev2,&off);
    */
  {
  int sum, i, remain, temp;

  ev2->from_sc = ev2->dist->LO_to_sc[ev2->left_offset + 1];
  ev2->to_sc = ev2->dist->RO_to_sc[ev2->right_offset + 1];
  ev2->range = (ev2->finish - ev2->start) + 1;
  ev2->sc_range = (ev2->to_sc - ev2->from_sc) + 1;

  remain = off;
  sum = 0;
  temp = ev2->range;
  for (i=0; i<8; i++) {
    temp = temp >> 1;
    /*
    printf(" temp %x %d sum %d remain %d\n", temp, temp, sum, remain);
    */
    if (temp <= remain) {
      remain -= temp;
      sum += power2[7-i];
      }
    } 
  
  ev2->sc_size = sum;
/*
printf(" temp %x %d sum %d remain %d\n", temp, temp, sum, remain);
*/
  ev2->off_sc = ((ev2->sc_range * sum) >> 8) + ev2->from_sc;
  }
    }
  else {
    off = (ev2->finish - ev1->start) + 1;
    chr_to_sc(ev1,&off); 

    off = (ev1->start - ev2->start) + 1;
    chr_to_sc(ev2,&off);
    }

  /*
  ev1->off_sc = (ev2->to_sc - (off / ev1->sc_size)) + 1;
  ev2->off_sc = (ev2->from_sc + (off / ev2->sc_size)) - 1;
  */

  prob1 = ev1->dist->sc_to_TP[ev1->off_sc] - (ev1->right_offset);
  prob2 = ev2->dist->sc_to_SP[ev2->off_sc] - (ev2->left_offset);
  sane_left = prob1;
  sane_right = prob2;

  prob_right = ev2->dist->sc_to_TP[ev2->off_sc] - ev2->right_offset;
  prob_left = ev1->dist->sc_to_SP[ev1->off_sc] - ev1->left_offset;
  
  denom1 = 100 - (ev1->left_offset + ev1->right_offset);
  denom2 = 100 - (ev2->left_offset + ev2->right_offset);
  /* 
  must_before = (denom1 * denom2 * gamma) / 100;
  */
  /* zzzzzzzzz
  must_before = mult_200_by_200[denom1][denom2] / 100;
  */
  must_before = 100;
  must_before = mult_200_by_200[must_before][gamma];

  /* The whole first interval is before the second interval */
  /*
  prob_before = prob_right * denom1;
  */
  prob_before = mult_200_by_200[prob_right][denom1];
  /*
  prob_before += prob_left * prob2;
  */
  prob_before += mult_200_by_200[prob_left][prob2];

/*
printf(" must_before %d prob_before %d denom1 %d prob2 %d\n",
must_before, prob_before, denom1, prob2);
*/

  /* Opposite testing */
  /*
  mal_target = (denom1 * denom2 * (100 - gamma)) / 100;
  */
  /* zzzzzzz
  mal_target = mult_200_by_200[denom1][denom2] / 100;
  */
  mal_target = 100;
  mal_target = mult_200_by_200[mal_target][100 - gamma];

  target = must_before - prob_before;
if (target!=1 || mal_target!=1) return TRUE;
  if (target < 0) return TRUE;

  free_nodes = 2;
  occupied_nodes = 1;
  nodes[1].from1 = ev1->off_sc;
  nodes[1].to1 = ev1->to_sc;
  nodes[1].prob1 = prob1;
  dist1 = ev1->dist;
  nodes[1].from2 = ev2->from_sc;
  nodes[1].to2 = ev2->off_sc;
  nodes[1].prob2 = prob2;
  dist2 = ev2->dist;
  /*nodes[1].next = 0;*/

  do {
    t = &nodes[occupied_nodes]; 
    occupied_nodes++;

    /* cannot satisfy? */
    /*
    if ((sane_left * sane_right) < target) break;
    */
    if ((mult_200_by_200[sane_left][sane_right]) < target) break;
/*
printf("target %d\n",target);
*/
    sane_left -= t->prob1;
    sane_right -= t->prob2;

  
    range1 = (t->to1 - t->from1) + 1;
    range2 = (t->to2 - t->from2) + 1;

/*
printf("range1 %d %d %d\n",range1, t->to1, t->from1);
printf("range2 %d %d %d\n",range2, t->to2, t->from2);
*/

    /* If down to a single super chronon, use uniform distribution */
    if (range1 <= 1) {
      mid1 = t->to1; 
      prob1_left = t->prob1 >> 1;
      prob1_right = prob1_left;
      out1 = TRUE;
      }
    else {
      mid1 = t->from1 + (range1 >> 1);
      prob1_left = dist1->sc_to_TP[t->from1] - dist1->sc_to_TP[mid1];
      prob1_right = dist1->sc_to_TP[mid1] - dist1->sc_to_TP[t->to1+1];
      out1 = FALSE;
      }
    if (range2 <= 1) {
      mid2 = t->to2; 
      prob2_left = t->prob2 >> 1;
      prob2_right = prob2_left;
      out2 = TRUE;
      }
    else {
      mid2 = t->from2 + (range2 >> 1); 
      prob2_left = dist2->sc_to_SP[mid2] - dist2->sc_to_SP[t->from2];
      prob2_right = dist2->sc_to_SP[t->to2] - dist2->sc_to_SP[mid2 - 1];
      out2 = FALSE;
      }
 
    /*
    mal_target -= prob1_right * prob2_left;
    */
    mal_target -= mult_200_by_200[prob1_right][prob2_left];
    /*
    target -= prob1_left * prob2_right;
    */
    target -= mult_200_by_200[prob1_left][prob2_right];

    /* satisfied? */
    if (target < 0) {
      return TRUE;
      }

    /* Opposite proved? */
    if (mal_target < 0) {
      return FALSE;
      }

/*
printf("mid1 %d %d %d\n",mid1, t->to1, t->from1);
printf("mid2 %d %d %d\n",mid2, t->to2, t->from2);
printf("prob1_left %d prob1_right %d\nprob2_left %d prob2_right %d\n",
        prob1_left, prob1_right, prob2_left, prob2_right);
*/       
    if (!out1 || !out2) {
      
      if (prob1_left && prob2_left) {
        sane_left += prob1_left + prob2_left;
        nodes[free_nodes].from1 = t->from1;
        nodes[free_nodes].to1 = mid1-1;
        nodes[free_nodes].prob1 = prob1_left;
        nodes[free_nodes].from2 = t->from2;
        nodes[free_nodes].to2 = mid2-1;
        nodes[free_nodes].prob2 = prob2_left;
        free_nodes++;
	}

      if (prob1_right && prob2_right) {
        sane_right += prob1_right + prob2_right;
        nodes[free_nodes].from1 = mid1;
        nodes[free_nodes].to1 = t->to1;
        nodes[free_nodes].prob1 = prob1_right;
        nodes[free_nodes].from2 = mid2;
        nodes[free_nodes].to2 = t->to2;
        nodes[free_nodes].prob2 = prob2_right;
        free_nodes++;
        }

      }
    } while (occupied_nodes != free_nodes);
  return FALSE;
}

/* figure out starting super chronon */
static void chr_to_sc(ind_type ev, unsigned long *diff)
{
  int sum, i, remain, temp;

  ev->from_sc = ev->dist->LO_to_sc[ev->left_offset + 1];
  ev->to_sc = ev->dist->RO_to_sc[ev->right_offset + 1];
  ev->range = (ev->finish - ev->start) + 1;
  ev->sc_range = (ev->to_sc - ev->from_sc) + 1;

  remain = *diff;
  sum = 0;
  temp = ev->range;
  for (i=0; i<8; i++) {
    temp = temp >> 1;
    /*
    printf(" temp %x %d sum %d remain %d\n", temp, temp, sum, remain);
    */
    if (temp <= remain) {
      remain -= temp;
      sum += power2[7-i];
      }
    } 
  
  ev->sc_size = sum;
printf(" temp %x %d sum %d remain %d\n", temp, temp, sum, remain);
  ev->off_sc = ((ev->sc_range * sum) >> 8) + ev->from_sc;

  /*
  printf("\nev\n");
  dump_ind_event(ev);
  */

  /*
  ev->sc_size = ev->range/ev->sc_range;
  */
}

static void dump_ind_event(ind_type ev)
{
  void printf();
  printf("  start  %d \n  finish  %d  \n  from_sc  %d  \n  to_sc  %d \n  sc_range  %d \n  range  %d \n  sc_size  %d \n  left_offset  %d  \n  right_offset  %d \n  off_sc %d ",
         ev->start, ev->finish, ev->from_sc, ev->to_sc, ev->sc_range, 
         ev->range, ev->sc_size, ev->left_offset, ev->right_offset, ev->off_sc);
}
