/***********************************************************************\ 
*                                                                       * 
*   File: calendric_system/newh/ucs/cs.h
*                                                                       * 
*   The MultiCal System is free software in the public domain; you can  * 
*   redistribute it and/or modify it as you wish. We ask that you       * 
*   retain credits referencing the University of Arizona and that you   * 
*   identify any changes you make.                                      * 
*                                                                       * 
*   Report problems to multical@cs.arizona.edu                          * 
*   Direct all inquiries to:    The MultiCal Project                    * 
*                               Department of Computer Science          * 
*                               University of Arizona                   * 
*                               Tucson, AZ 85721                        * 
*                               U.S.A.                                  * 
*                                                                       * 
\***********************************************************************/ 
#ifndef cs_include
#define cs_include

#include "ucs/binding.h"

/* calendric system data structures
 */


typedef struct {
    char *function_name;
    int num_params;
    formal_arg_type *list_params;
    formal_arg_type return_type;
    error_type (*actual_function)(actual_arg_type array[], actual_arg_type *return_val);
    int function_number;
} function_entry_type;

typedef struct {
	char *name;   
	int calendar_number;
	int num_functions;
	function_entry_type *functions;
	int num_field_names;
	char **field_names;
	value_array_type *field_values;
} calendar_type;

/* epoch/calendar
 */

typedef struct {
	interval_type epoch;
	calendar_type *calendar;
} epoch_type;

typedef struct {
        char *name;
	int  num_epochs;
        epoch_type *epochs;
} calendric_system_type;

/* declaration for the generator */
void init_gen();
/* where to put these decls? they are in the called init_gen() */
void init_calendars();
void init_properties();
error_type ucs_declare_local_calendric_system(char*);
error_type ucs_declare_global_calendric_system(char*);

#endif
