/***********************************************************************\ 
*                                                                       * 
*   File: calendric_system/newh/ucs/init.h
*                                                                       * 
*   The MultiCal System is free software in the public domain; you can  * 
*   redistribute it and/or modify it as you wish. We ask that you       * 
*   retain credits referencing the University of Arizona and that you   * 
*   identify any changes you make.                                      * 
*                                                                       * 
*   Report problems to multical@cs.arizona.edu                          * 
*   Direct all inquiries to:    The MultiCal Project                    * 
*                               Department of Computer Science          * 
*                               University of Arizona                   * 
*                               Tucson, AZ 85721                        * 
*                               U.S.A.                                  * 
*                                                                       * 
\***********************************************************************/ 
#ifndef ucs_init_include
#define ucs_init_include

/* ucs_init.h
*
*  This file includes declarations for all the initilization routines
*  defined for the UCS.
*/

/*
*  Routine:  ucs_init
*
*  Description:  Called by the tadt at the time of initialization
*		 
*
*  Arguments:  None
*
*  Return Value: Error code
*
*  Errors: None
*
*  Side Effects: Allocates memory through tadt
*/


error_type ucs_init();


#define Num_Calendric_Systems 2

#define Tc_Calendric_Sys_Name "Timecard"
#define Num_Tc_CS_Epochs 1

#define Am_Calendric_Sys_Name "American"
#define Num_Am_CS_Epochs 5

char *Am_CS_Names[];

#endif
