/***********************************************************************\ 
*                                                                       * 
*   File: calendric_system/newh/ucs/property_ext.h
*                                                                       * 
*   The MultiCal System is free software in the public domain; you can  * 
*   redistribute it and/or modify it as you wish. We ask that you       * 
*   retain credits referencing the University of Arizona and that you   * 
*   identify any changes you make.                                      * 
*                                                                       * 
*   Report problems to multical@cs.arizona.edu                          * 
*   Direct all inquiries to:    The MultiCal Project                    * 
*                               Department of Computer Science          * 
*                               University of Arizona                   * 
*                               Tucson, AZ 85721                        * 
*                               U.S.A.                                  * 
*                                                                       * 
\***********************************************************************/ 
#ifndef property_include
#define property_include


/*
* Definitions of property data types 
*/ 

typedef enum {   ucs_locale_pn,
		 ucs_event_input_format_pn,  ucs_event_output_format_pn, 
		 ucs_span_input_format_pn, ucs_span_output_format_pn,
		 ucs_interval_input_format_pn, ucs_interval_output_format_pn,
		 ucs_override_input_epoch_pn, 
		 ucs_beginning_pn, ucs_forever_pn
	       } property_name_labels;

#define NUM_PROPERTIES 10

/* 
* Array of property_types point to the most recent property value
*/

typedef struct {
    	property_name_labels num;
	char *val;
} property_type;

/*
* each property_element contains the current property value and 
* points to the most recent property value. 
* when a property_pop is performed, updating the pointer
* to the most recent value of this property is very efficient
*/

typedef struct {
        char *value;
	struct property_element *previous_value;
} *property_element_type;


typedef struct encoded_format {
    int length;
    int capacity;
    char *value;
} encoded_format_type;


#define max_coded_property_size  256
#define max_property_name        256


#endif
