/* Test code for the determinate sequence */
#include <stdio.h>
#include <stdlib.h>
#include <sys/time.h>
#include "system_wide.h"
#include "tadt.h"
#define EVENTS_IN_R 4
#define INTERVALS_IN_P 3

#define UNOPTIMIZED

context_space_type context_space;
context_type context = &context_space;

void main()
{
  event_space_type recieved[EVENTS_IN_R];
  event_space_type recieved_upack[EVENTS_IN_R];
  event_space_type starting_in_production[INTERVALS_IN_P];
  event_space_type terminating_in_production[INTERVALS_IN_P];
  event_space_type starting_in_production_upack[INTERVALS_IN_P];
  event_space_type terminating_in_production_upack[INTERVALS_IN_P];
  interval_space_type in_production[INTERVALS_IN_P];
  interval_space_type in_production_upack[INTERVALS_IN_P];
  int i, r, p, temp;
  void printf(), gettimeofday();
  struct timeval tp1, tp2;
  int temp1, temp2;

  context->precision.precision = 5;

  error_handler();
  tadt_init();

  /* Initialize Recieved */
  for (i=0;i<EVENTS_IN_R;i++) {
    recieved[i].determinate.ts_type = determinate;
    recieved[i].determinate.sign = 0;
    }

#ifdef NORMAL
  recieved[0].determinate.data = 25;
  recieved[1].determinate.data = 25;
  recieved[2].determinate.data = 27;
  recieved[3].determinate.data = 27;
#else
  recieved[0].determinate.data = 25*1440 + 40;          
  recieved[1].determinate.data = 25*1440 + 340;
  recieved[2].determinate.data = 27*1440 + 20;
  recieved[3].determinate.data = 27*1440 + 277;
#endif

  /* Initialize In_Production */
  for (i=0;i<INTERVALS_IN_P;i++) {
    starting_in_production[i].determinate.ts_type = determinate;
    starting_in_production[i].determinate.sign = 0;
    terminating_in_production[i].determinate.ts_type = determinate;
    terminating_in_production[i].determinate.sign = 0;
    }

  starting_in_production[0].determinate.data = 1;
  starting_in_production[1].determinate.data = 24;
  starting_in_production[2].determinate.data = 60;
  starting_in_production[3].determinate.data = 100;

  terminating_in_production[0].determinate.data = 2;
  terminating_in_production[1].determinate.data = 28;
  terminating_in_production[2].determinate.data = 70;
  terminating_in_production[3].determinate.data = 200;

  for (i=0;i<INTERVALS_IN_P;i++) {
    in_production[i].start = &starting_in_production[i];
    in_production[i].terminate = &terminating_in_production[i];
    in_production_upack[i].start = &starting_in_production_upack[i];
    in_production_upack[i].terminate = &terminating_in_production_upack[i];
    }

  /*
  for (r=0;r<EVENTS_IN_R;r++) dump_event(&recieved[r]," event ");
  for (r=0;r<INTERVALS_IN_P;r++) dump_event(&starting_in_production[r]," start ");
  for (r=0;r<INTERVALS_IN_P;r++) dump_event(&starting_in_production[r]," terminate ");
  */

  temp = 0;


  for (r=0;r<EVENTS_IN_R;r++) 
    tadt_unpack_e(&recieved[r],&recieved_upack[r]);
  r = 0;
  p = 0;

      gettimeofday(&tp1,NULL);
#define NUMBER_OF_RUNS 1000000
  for (i=0;i<NUMBER_OF_RUNS;i++) {

  for (p=0;p<INTERVALS_IN_P;p++) {
    tadt_unpack_i(&in_production[p],&in_production_upack[p]);
#ifdef OPTIMIZED
    scale_opt(in_production_upack[p].start, in_production_upack[p].start);
    scale_opt(in_production_upack[p].terminate, in_production_upack[p].terminate);
#endif
    }
  for (r=0;r<EVENTS_IN_R;r++) {
    tadt_unpack_e(&recieved[r],&recieved_upack[r]);
#ifdef UNOPTIMIZED
    scale(&recieved_upack[r], &recieved_upack[r]);
#endif
    }
  if (r == p) exit(1);

  for (p=0;p<INTERVALS_IN_P;p++) {
    for (r=0;r<EVENTS_IN_R;r++) {
      if (tadt_e_precedes_e(&recieved_upack[r],
			    in_production_upack[p].terminate)) temp += 1;
      if (tadt_e_precedes_e(in_production_upack[p].start, 
			      &recieved_upack[r])) temp += 1;
      }
   }
   }
      gettimeofday(&tp2,NULL);

      temp1 = tp1.tv_sec * 1000000 + tp1.tv_usec;
      temp2 = tp2.tv_sec * 1000000 + tp2.tv_usec;
      temp1 = temp2 - temp1;

      printf( "timings %d\n", temp1/NUMBER_OF_RUNS);
      printf("number of results %d\n", temp);

}

#ifdef OPTIMIZED
scale_opt(event_type ev) {
   tadt_fs_times_n((span_type) ev, 1440, (span_type) ev);
}
#endif

#ifdef UNOPTIMIZED
scale(event_type ev) {
   tadt_fs_div_n((span_type) ev, 1440, (span_type) ev);
   /*
   tadt_fs_div_n((span_type) ev, 60, (span_type) ev);
   tadt_fs_div_n((span_type) ev, 24, (span_type) ev);
   */
}
#endif
