/***********************************************************************\ 
*                                                                       * 
*   File: calendric_system/tadt/test/random.c
*                                                                       * 
*   The MultiCal System is free software in the public domain; you can  * 
*   redistribute it and/or modify it as you wish. We ask that you       * 
*   retain credits referencing the University of Arizona and that you   * 
*   identify any changes you make.                                      * 
*                                                                       * 
*   Report problems to multical@cs.arizona.edu                          * 
*   Direct all inquiries to:    The MultiCal Project                    * 
*                               Department of Computer Science          * 
*                               University of Arizona                   * 
*                               Tucson, AZ 85721                        * 
*                               U.S.A.                                  * 
*                                                                       * 
\***********************************************************************/ 
#include <stdio.h>
#include <sys/time.h>
#include "system_wide.h"
#include "tadt.h"

#ifdef TESTING
static int numoftrials = 1; /*300*/;
#else
static int numoftrials = 1; /*10*/ /*300*/;
#endif
static node_space_type nodes[DIST_MAX*2];
static int free_nodes, occupied_nodes;
#define SEED 0x2F678324
#define PERIOD_OF_INDETERMINACY 2000000
#define NUM_OF_GAMMAS 50
static int gammas[NUM_OF_GAMMAS] = {
1,2,4,6,8,
10,12,14,16,18,
20,22,24,26,28,
30,32,34,36,38,
40,42,44,46,48,
50,52,54,56,58,
60,62,64,66,68,
70,72,74,76,78,
80,82,84,86,88,
90,92,94,96,98};
#define NUM_OF_EVENTS 10
#define NUM_OF_WIDTHS 50
#define MAX_WIDTH 50
static int widths[NUM_OF_WIDTHS];
static event_type events[NUM_OF_EVENTS];
static timings[NUM_OF_GAMMAS][NUM_OF_WIDTHS];

int main() {
  int i, j, k;
  bool before(), eval;
  void printf();
  struct timeval tp1, tp2;
  int temp1, temp2;
  int max_start;
  int ev1, ev2;

  srand(SEED);
  temp1 = 1;
  for (i=SIG_BITS; i>0; i--) temp1 = temp1*2;

  for (i=0;i<NUM_OF_EVENTS;i++) {
    events[i] = tadt_allocate_e(upack);
    events[i]->upack.ts_type = upackind;
    events[i]->upack_ind.distribution.name = UNIFORM;
    }
    
  for (i=0;i<NUM_OF_WIDTHS;i++) {
    widths[i] = ((i*(MAX_WIDTH/NUM_OF_WIDTHS)) * PERIOD_OF_INDETERMINACY) + 1;
    }

#ifdef TESTING
  for (k=0;k<1;k++) {
#else
  for (k=0;k<NUM_OF_WIDTHS;k++) {
#endif

    for (j=0;j<NUM_OF_EVENTS;j++) {
       temp1 = rand() % widths[k];
       events[j]->upack_ind.lower.seconds = temp1 + 1;
       events[j]->upack_ind.upper.seconds = temp1 + PERIOD_OF_INDETERMINACY;
       }

    for (i=0;i<NUM_OF_GAMMAS;i++) {
       
      gettimeofday(&tp1,NULL);
      for (ev1=0;ev1<NUM_OF_EVENTS;ev1++) {
        for (ev2=0;ev2<NUM_OF_EVENTS;ev2++) {

          for (j=0; j<numoftrials; j++) eval = tadti_e_precedes_e(gammas[i], events[ev1], events[ev2]);
          }
        }

      gettimeofday(&tp2,NULL);

      temp1 = tp1.tv_sec * 1000000 + tp1.tv_usec;
      temp2 = tp2.tv_sec * 1000000 + tp2.tv_usec;
      temp1 = temp2 - temp1;

      timings[i][k] = temp1/(numoftrials*NUM_OF_EVENTS*NUM_OF_EVENTS);

      }
    }

  for (i=0;i<NUM_OF_GAMMAS;i++) {
    for (k=0;k<NUM_OF_WIDTHS;k++) {
      printf("%d\n", timings[i][k]);
      }
    printf("\n");
    }
  return TRUE;
}
